/**
 * scriptloader.js
 *
 * Script loader, specially for CDN fallback behavior.
 * Adapted from Steve Souders code (thanks Steve) by
 * Anderson G. Martins from Joomla Bamboo.
 *
 * Added the option to set a fallback URL, which will be used
 * trying to load a local copy of the requested file.
 *
 * @package		Zen Library
 * @version		1.0.2
 * @author		Joomla Bamboo - design@joomlabamboo.com
 * @copyright 	Copyright (c) 2013 Joomla Bamboo. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 *//**
 * loadScript
 *
 * @author  Steve Sourders, Anderson G. Martins
 * @param   String    url          URL where we find the script to load it.
 * @param   String    fallbackURL  The local URL that will be called if remote URL fails
 * @param   Function  callback     The function that will be called after complete loaded.
 */function loadScript(e,t,n){var r=document.createElement("script");r.type="text/javascript";if(r.readyState)r.onreadystatechange=function(){if(r.readyState=="loaded"||r.readyState=="complete"){r.onreadystatechange=null;typeof n=="function"&&n()}else r.readyState=="error"&&typeof t=="string"&&t!==""&&loadScript(t,null,n)};else{r.onload=function(){typeof n=="function"&&n()};r.onerror=function(){typeof t=="string"&&t!==""&&loadScript(t,null,n)}}r.src=e;document.getElementsByTagName("head")[0].appendChild(r)};